﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace ControlLibrary
{
    public interface IHashAlgorithm
    {
        string ComputeHash(string data);
    }

    public class MD5Hash : IHashAlgorithm
    {
        private HashAlgorithm _algo;
        public MD5Hash()
        {
            _algo = HashAlgorithm.Create("MD5");
        }
        public string ComputeHash(string data)
        {
            string HexText = "";

            var byteData = Encoding.UTF8.GetBytes(data);
            var hash = _algo.ComputeHash(byteData);
            foreach (char c in hash)
            {
                HexText += string.Format("{0:x2}", (uint)System.Convert.ToUInt32(c));
            }
            return HexText;
        }
    }
    public class SHA1 : IHashAlgorithm
    {
        private HashAlgorithm _algo;
        public SHA1()
        {
            _algo = HashAlgorithm.Create("SHA1");
        }
        public string ComputeHash(string data)
        {
            string HexText = "";

            var byteData = Encoding.UTF8.GetBytes(data);
            var hash = _algo.ComputeHash(byteData);
            foreach (char c in hash)
            {
                HexText += string.Format("{0:x2}", (uint)System.Convert.ToUInt32(c));
            }
            return HexText;

        }
    }
    public class SHA256 : IHashAlgorithm
    {
        private HashAlgorithm _algo;
        public SHA256()
        {
            _algo = HashAlgorithm.Create("SHA1");
        }
        public string ComputeHash(string data)
        {
            string HexText = "";

            var byteData = Encoding.UTF8.GetBytes(data);
            var hash = _algo.ComputeHash(byteData);
            foreach (char c in hash)
            {
                HexText += string.Format("{0:x2}", (uint)System.Convert.ToUInt32(c));
            }
            return HexText;
        }
    }
    public class SHA512 : IHashAlgorithm
    {
        private HashAlgorithm _algo;
        public SHA512()
        {
            _algo = HashAlgorithm.Create("SHA512");
        }
        public string ComputeHash(string data)
        {
            string HexText = "";

            var byteData = Encoding.UTF8.GetBytes(data);
            var hash = _algo.ComputeHash(byteData);
            foreach (char c in hash)
            {
                HexText += string.Format("{0:x2}", (uint)System.Convert.ToUInt32(c));
            }
            return HexText;
        }
    }
}


          


